import click
import os

plugin_folder = os.path.join(os.path.dirname(__file__), 'commands')


class UovoCLI(click.MultiCommand):
    """_summary_
    https://click.palletsprojects.com/en/8.0.x/commands/#custom-multi-commands
    Click Custom Multi Commands

    Args:
        click (_type_): _description_
    """

    def list_commands(self, ctx):
        rv = []
        for filename in os.listdir(plugin_folder):
            if filename.endswith('.py') and filename != '__init__.py':
                rv.append(filename[:-3])
        rv.sort()
        return rv

    def get_command(self, ctx, name):
        ns = {}
        fn = os.path.join(plugin_folder, name + '.py')
        with open(fn) as f:
            code = compile(f.read(), fn, 'exec')
            eval(code, ns, ns)
        return ns['uovo']


uovo = UovoCLI(help='This tool\'s subcommands are loaded from a '
               'plugin folder dynamically.')

if __name__ == '__main__':
    uovo()
